/**
 *
 *
  _____                      _              _ _ _     _   _     _        __ _ _
 |  __ \                    | |            | (_) |   | | | |   (_)      / _(_) |
 | |  | | ___    _ __   ___ | |_    ___  __| |_| |_  | |_| |__  _ ___  | |_ _| | ___
 | |  | |/ _ \  | '_ \ / _ \| __|  / _ \/ _` | | __| | __| '_ \| / __| |  _| | |/ _ \
 | |__| | (_) | | | | | (_) | |_  |  __/ (_| | | |_  | |_| | | | \__ \ | | | | |  __/
 |_____/ \___/  |_| |_|\___/ \__|  \___|\__,_|_|\__|  \__|_| |_|_|___/ |_| |_|_|\___|

 * DO NOT EDIT THIS FILE!!
 *
 *  FOR CUSTOMIZE cuponBaseService PLEASE EDIT ../cupon.service.ts
 *
 *  -- THIS FILE WILL BE OVERWRITTEN ON THE NEXT SKAFFOLDER'S CODE GENERATION --
 *
 */
 // DEPENDENCIES
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { HttpClient } from '@angular/common/http';

// CONFIG
import { environment } from '../../../environments/environment';

// MODEL
import { Cupon } from '../../domain/gifloadmin_db/cupon';

/**
 * THIS SERVICE MAKE HTTP REQUEST TO SERVER, FOR CUSTOMIZE IT EDIT ../Cupon.service.ts
 */

/*
 * SCHEMA DB Cupon
 *
	{
		codigo: {
			type: 'String'
		},
		estado: {
			type: 'String'
		},
		fechaFin: {
			type: 'Date'
		},
		fechaInicio: {
			type: 'Date'
		},
		mensaje: {
			type: 'String'
		},
		plan: {
			type: 'String'
		},
		porciento: {
			type: 'Decimal'
		},
		//RELATIONS
		//EXTERNAL RELATIONS
		cupon: {
			type: Schema.ObjectId,
			ref : "Plan"
		},
	}
 *
 */
@Injectable()
export class CuponBaseService {

    contextUrl: string = environment.endpoint + '/system/cupon';
    constructor(
        protected http: HttpClient
        ) { }

    // CRUD METHODS

    /**
    * CuponService.create
    *   @description CRUD ACTION create
    *   @param Cupon obj Object to insert
    *
    */
    create(item: Cupon): Observable<Cupon> {
        return this.http
            .post<Cupon>(this.contextUrl, item)
            .pipe(map(data => data));
    }

    /**
    * CuponService.delete
    *   @description CRUD ACTION delete
    *   @param ObjectId id Id Cupon
    *
    */
    remove(id: string): Observable<void> {
        return this.http
            .delete<void>(this.contextUrl + '/' + id)
            .pipe(map(data => data));
    }

    /**
    * CuponService.get
    *   @description CRUD ACTION get
    *   @param ObjectId id Id Cupon
    *   @returns Cupon
    *
    */
    get(id: string): Observable<Cupon> {
        return this.http
            .get<Cupon>(this.contextUrl + '/' + id)
            .pipe(map(data => data));
    }

    /**
    * CuponService.list
    *   @description CRUD ACTION list
    *   @returns ARRAY OF Cupon
    *
    */
    list(): Observable<any> {
        return this.http
            .get<any>(this.contextUrl,{ params: { 'page': 0, 'size': 500 } });
    }

    /**
    * CuponService.update
    *   @description CRUD ACTION update
    *   @param ObjectId id Id Cupon
    *   @returns Cupon
    *
    */
    update(item: Cupon): Observable<Cupon> {
        return this.http
            .put<Cupon>(this.contextUrl + '/' + item.id, item)
            .pipe(map(data => data));
    }


    // Custom APIs

}
